VST 3 Interfaces VST 3.6.11 SDK for developing VST Plug-in

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | Static Public Attributes | List of all members
IEditController Class Referenceabstract
VST 3 Interfaces to be implemented by the Plug-in | VST 3 Interfaces defined in version 3.0.0

Edit controller component interface. More...

`#include <ivsteditcontroller.h>`

Inheritance diagram for IEditController:

## Public Member Functions
virtual tresult | setComponentState (IBStream *state)=0
| Receives the component state. More...
virtual tresult | setState (IBStream *state)=0
| Sets the controller state. More...
virtual tresult | getState (IBStream *state)=0
| Gets the controller state. More...
virtual int32 | getParameterCount ()=0
| Returns the number of parameters exported. More...
virtual tresult | getParameterInfo (int32 paramIndex, ParameterInfo &info)=0
| Gets for a given index the parameter information. More...
virtual tresult | getParamStringByValue (ParamID id, ParamValue valueNormalized, String128 string)=0
| Gets for a given paramID and normalized value its associated string representation. More...
virtual tresult | getParamValueByString (ParamID id, TChar *string, ParamValue &valueNormalized)=0
| Gets for a given paramID and string its normalized value. More...
virtual ParamValue | normalizedParamToPlain (ParamID id, ParamValue valueNormalized)=0
| Returns for a given paramID and a normalized value its plain representation (for example 90 for 90db - see Automation). More...
virtual ParamValue | plainParamToNormalized (ParamID id, ParamValue plainValue)=0
| Returns for a given paramID and a plain value its normalized value. More...
virtual ParamValue | getParamNormalized (ParamID id)=0
| Returns the normalized value of the parameter associated to the paramID. More...
virtual tresult | setParamNormalized (ParamID id, ParamValue value)=0
| Sets the normalized value to the parameter associated to the paramID. More...
virtual tresult | setComponentHandler (IComponentHandler *handler)=0
| Gets from host a handler. More...
virtual IPlugView * | createView (FIDString name)=0
| Creates the editor view of the Plug-in, currently only "editor" is supported, see ViewType. More...
Public Member Functions inherited from IPluginBase
virtual tresult | initialize (FUnknown *context)=0
virtual tresult | terminate ()=0
Public Member Functions inherited from FUnknown
virtual tresult | queryInterface (const TUID _iid, void **obj)=0
virtual uint32 | addRef ()=0
virtual uint32 | release ()=0

## Static Public Attributes
static const FUID | iid
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid

## Detailed Description

Edit controller component interface.

- [plug imp]
- [released: 3.0.0]

The Controller part of an effect or instrument with parameter handling (export, definition, conversion...).

See also
  IComponent::getControllerClassId, IMidiMapping

## Member Function Documentation

virtual tresult setComponentState | ( | IBStream * | state | ) |
| pure virtual

Receives the component state.

Implemented in EditController.

virtual tresult setState | ( | IBStream * | state | ) |
| pure virtual

Sets the controller state.

Implemented in EditController, and SingleComponentEffect.

virtual tresult getState | ( | IBStream * | state | ) |
| pure virtual

Gets the controller state.

Implemented in EditController, and SingleComponentEffect.

virtual int32 getParameterCount | ( |  | ) |
| pure virtual

Returns the number of parameters exported.

Implemented in EditController.

virtual tresult getParameterInfo | ( | int32 | paramIndex,
|  | ParameterInfo & | info
| ) |  |
| pure virtual

Gets for a given index the parameter information.

Implemented in EditController.

virtual tresult getParamStringByValue | ( | ParamID | id,
|  | ParamValue | valueNormalized,
|  | String128 | string
| ) |  |
| pure virtual

Gets for a given paramID and normalized value its associated string representation.

Implemented in EditController.

virtual tresult getParamValueByString | ( | ParamID | id,
|  | TChar * | string,
|  | ParamValue & | valueNormalized
| ) |  |
| pure virtual

Gets for a given paramID and string its normalized value.

Implemented in EditController.

virtual ParamValue normalizedParamToPlain | ( | ParamID | id,
|  | ParamValue | valueNormalized
| ) |  |
| pure virtual

Returns for a given paramID and a normalized value its plain representation (for example 90 for 90db - see Automation).

Implemented in EditController.

virtual ParamValue plainParamToNormalized | ( | ParamID | id,
|  | ParamValue | plainValue
| ) |  |
| pure virtual

Returns for a given paramID and a plain value its normalized value.

(see Automation)

Implemented in EditController.

virtual ParamValue getParamNormalized | ( | ParamID | id | ) |
| pure virtual

Returns the normalized value of the parameter associated to the paramID.

Implemented in EditController.

virtual tresult setParamNormalized | ( | ParamID | id,
|  | ParamValue | value
| ) |  |
| pure virtual

Sets the normalized value to the parameter associated to the paramID.

The controller must never pass this value-change back to the host via the IComponentHandler. It should update the according GUI element(s) only!

Implemented in EditController.

virtual tresult setComponentHandler | ( | IComponentHandler * | handler | ) |
| pure virtual

Gets from host a handler.

Implemented in EditController.

virtual IPlugView* createView | ( | FIDString | name | ) |
| pure virtual

Creates the editor view of the Plug-in, currently only "editor" is supported, see ViewType.

The life time of the editor view will never exceed the life time of this controller instance.

Implemented in EditController.

## Member Data Documentation

const FUID iid
| static

Empty

Copyright ©2018 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.